Subject: [quicwg/base-drafts] Packet header bit order (#461)

From: MikkelFJ <[email-masked]>
Date: Sun, 23 Apr 2017 05:42:17 -0700

https://quicwg.github.io/base-drafts/draft-ietf-quic-transport.html#rfc.section.5.1

The graphic seems to suggest that bit 0 indicates a long header given the bit numbering sequence, but it appears to be encoded as bit 7.

```
 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+
|1|   Type (7)  |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                               |
+                       Connection ID (64)                      +
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                       Packet Number (32)                      |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                         Version (32)                          |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                          Payload (*)                        ...
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
```

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/issues/461

---

From: Martin Thomson <[email-masked]>
Date: Sun, 23 Apr 2017 16:11:32 -0700

Hah, that's a pretty obvious error.  You are right: that is bit 7.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/issues/461#issuecomment-296495858

---

From: Martin Thomson <[email-masked]>
Date: Sun, 23 Apr 2017 17:57:08 -0700

So I obviously didn't understand at first.  The concern is the numbering in the graphic.  I'm going to recommend that we break with tradition and number the packet diagrams in the opposite order, i.e.:

```
 3   2                   1                   0
 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
```

@janaiyengar, @MikeBishop, you might care about this, WDYT?

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/issues/461#issuecomment-296502101

---

From: ekr <[email-masked]>
Date: Sun, 23 Apr 2017 18:46:12 -0700

This seems like an idea that is going to cause a lot of confusion.

-Ekr

On Sun, Apr 23, 2017 at 8:57 PM, Martin Thomson <[email-masked]>
wrote:

> So I obviously didn't understand at first. The concern is the numbering in
> the graphic. I'm going to recommend that we break with tradition and number
> the packet diagrams in the opposite order, i.e.:
>
>  3   2                   1                   0
> @janaiyengar <https://github.com/janaiyengar>, @MikeBishop
> <https://github.com/MikeBishop>, you might care about this, WDYT?
>
> —
> Reply to this email directly, view it on GitHub
> <https://github.com/quicwg/base-drafts/issues/461#issuecomment-296502101>,
> or mute the thread
> <https://github.com/notifications/unsubscribe-auth/ABD1oWWlcW4xwqZUMMGRpf4YubKd0rwsks5ry_NkgaJpZM4NFZYf>
> .
>

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/issues/461#issuecomment-296506401

---

From: janaiyengar <[email-masked]>
Date: Mon, 24 Apr 2017 19:46:39 -0700

Yeah -- I agree this will cause confusion. I think it's fine to simply
change bit 0 to bit 7.

On Sun, Apr 23, 2017 at 6:46 PM, ekr <[email-masked]> wrote:

> > <https://github.com/quicwg/base-drafts/issues/461#issuecomment-296502101
> >,
> > or mute the thread
> > <https://github.com/notifications/unsubscribe-auth/
> ABD1oWWlcW4xwqZUMMGRpf4YubKd0rwsks5ry_NkgaJpZM4NFZYf>
> > .
> >
>
> —
> You are receiving this because you were mentioned.
> <https://github.com/quicwg/base-drafts/issues/461#issuecomment-296506401>,
> or mute the thread
> <https://github.com/notifications/unsubscribe-auth/AKjg1KVeC6Q4lfMjxN332xEfFMcdWFtnks5ry_7kgaJpZM4NFZYf>
> .
>

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/issues/461#issuecomment-296876862

---

From: MikkelFJ <[email-masked]>
Date: Tue, 25 Apr 2017 00:35:29 -0700

How about one of these?
```
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|       0       |       1       |       2       |       3       |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|0 1 2 3 4 5 6 7|0 1 2 3 4 5 6 7|0 1 2 3 4 5 6 7|0 1 2 3 4 5 6 7|
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
| Type (7)    |1|
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                               |
+                       Connection ID (64)                      +
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                       Packet Number (32)                      |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                         Version (32)                          |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                          Payload (*)                        ...
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|       0       |       1       |       2       |       3       |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|7 6 5 4 3 2 1 0|7 6 5 4 3 2 1 0|7 6 5 4 3 2 1 0|7 6 5 4 3 2 1 0|
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|1| Type (7)    |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                               |
+                       Connection ID (64)                      +
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                       Packet Number (32)                      |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                         Version (32)                          |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                          Payload (*)                        ...
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
```

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/issues/461#issuecomment-296942315